/****************************************************************************/
/* PAB Jul 2007                                                             */
/****************************************************************************/

#include <stdlib.h>
#include <stdio.h>

#include <bfm.h>
#include <bfmcommfake.h>

template<class Float>
void bfmcommfake<Float>::comm_init (void){}
template<class Float>
void bfmcommfake<Float>::comm_end (void){}

// cb is cb of result, 1-cb is cb of input field, and it is this
// we communicate
template<class Float>
void bfmcommfake<Float>::comm_start(int result_cb, Fermion_t psi,int dag)
{
  comm(result_cb,psi,dag);
}
template<class Float>
void bfmcommfake<Float>::comm_complete(int result_cb, Fermion_t psi )
{
}
template<class Float>
void bfmcommfake<Float>::comm(int result_cb, Fermion_t psi, int dag)
{

  int nspinco = 12;
  int cb = 1-result_cb;

  int me = this->thread_barrier();
  for(int mu=0;mu<ND;mu++){
    for(int pm=0;pm<2;pm++ ) {

      int ftcb =0;
      int dir=pm+2*mu;
      int sgn =pm;
      Float *comm_buf = this->sendbufs[dir];

      if ( dag ) sgn = 1-pm;

      if ( this->precon_5d ) ftcb = 0;
      else ftcb = result_cb;
      int idx=2*mu+pm; 
      
      Float *psi_t = (Float *) psi;  
      this->recvbufs[idx] = &psi_t[this->comm_offset[pm][mu]*SPINOR_SIZE*this->simd()*this->cbLs];

      if ( (!this->local_comm[mu])  ) {
	printf("comm fake is broken; should us gather_proj\n");
	exit(-1);
      }

      if (this->simd_grid[mu]>1) {

	int thrvol,throff;
	this->thread_work_nobarrier(this->simd_nbound[mu],me,thrvol,throff);

	integer args[9];
	args[0] = (integer) &this->face_table[ftcb][pm][mu][throff];
	args[1] = (integer) psi;
	args[2] = (integer) throff;
	args[3] = (integer) this->recvbufs[dir];
	args[4] = (integer) thrvol;
	args[5] = (integer) this->cbLs;
	args[6] = sgn+2*mu;
	args[7] = (integer) this->complex_i_simd;

	integer arg_p = (integer) args;

	if ( sizeof(Float) == sizeof(double ) ) vmx_gather_proj_perm(arg_p);
	else                                    vmx_gather_proj_perm_s(arg_p);

      }
    }
  }

}


template class bfmcommfake<float>;
template class bfmcommfake<double>;
