#ifndef _BFM_BAGEL2_H_
#define _BFM_BAGEL2_H_

template <class Float>
class bfmdop : public bfmbase<Float> {

 public:
  // Adds fields that are specific to the Bagel2 implementation
  // of bfm
  Float *two_spinor;
  // Move to a densely packed tables and store CB info and is_halo mask
  short_integer *shift_table[Ncb];
  integer *cb_table[Ncb];
  integer *face_table[Ncb][NMinusPlus][ND];
  int comm_offset[NMinusPlus][ND];

  // Buffers
  Float *sendbufs[8];
  Float *recvbufs[8];
  double *complex_i_simd;

  //////////////////////////////////////////////////////////////////////
  // Methods implemented here
  //////////////////////////////////////////////////////////////////////

  // More sta
  virtual void init(bfmarg &arg) ; 
  virtual void end (void) ;

  virtual integer bagel_idx   (int site[4],int reim,int i, int i_size,int half_cb) ;
  virtual integer bagel_idx5d (int site[4],int s,int reim,int i, int i_size,int half_cb);
  virtual integer bagel_idx5d (int site,int s,int i_size) ;



  virtual void dslash(Fermion_t chi, 
		      Fermion_t psi, 
		      int cb,
		      int dag) ;

  virtual double dslash_generic(Fermion_t chi, 
		      Fermion_t psi_in, 
		      Fermion_t psi_out, 
		      int cb,
		      int dag,int dperp=1, int addscale=0, double a=0,double b=0) ;


  virtual int simd(void) ;
  virtual void pointers_init(void) ;
  virtual void pointers_end(void) ; 

  int  parity(int x[4]);
  int  psite (int x[4],int latt[4]);
  int  interleave_site(int pm,int mu, int site);

  void bgq_l1p_optimisation(int mode);

  void gather_proj(integer *sites,
                   Float     *psi,
                   integer comm_off, 
                   Float  *comm_buf,
                   integer nface,
  	           int permute, 
                   int Ls,
		   int pm,
		   int mu
		   );


};

#endif
